/* Daemon.c generated by valac 0.45.91, the Vala compiler
 * generated from Daemon.vala, do not modify */

/*
 * Copyright 2018 elementary, Inc. (https://elementary.io)
 *           2014 Corentin Noël <corentin@elementary.io>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <gee.h>
#include <libecal/libecal.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include "elementary-calendar.h"
#include <libedataserver/libedataserver.h>
#include <libical-glib/libical-glib.h>
#include <float.h>
#include <math.h>
#include <granite.h>

#define MAYA_TYPE_DAEMON (maya_daemon_get_type ())
#define MAYA_DAEMON(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), MAYA_TYPE_DAEMON, MayaDaemon))
#define MAYA_DAEMON_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), MAYA_TYPE_DAEMON, MayaDaemonClass))
#define MAYA_IS_DAEMON(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), MAYA_TYPE_DAEMON))
#define MAYA_IS_DAEMON_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), MAYA_TYPE_DAEMON))
#define MAYA_DAEMON_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), MAYA_TYPE_DAEMON, MayaDaemonClass))

typedef struct _MayaDaemon MayaDaemon;
typedef struct _MayaDaemonClass MayaDaemonClass;
typedef struct _MayaDaemonPrivate MayaDaemonPrivate;
enum  {
	MAYA_DAEMON_0_PROPERTY,
	MAYA_DAEMON_NUM_PROPERTIES
};
static GParamSpec* maya_daemon_properties[MAYA_DAEMON_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
typedef struct _Block1Data Block1Data;
typedef struct _Block2Data Block2Data;
typedef struct _Block3Data Block3Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_ECalComponentAlarmTrigger_free0(var) ((var == NULL) ? NULL : (var = (_vala_ECalComponentAlarmTrigger_free (var), NULL)))
#define __vala_ECalComponentAlarm_free0(var) ((var == NULL) ? NULL : (var = (_vala_ECalComponentAlarm_free (var), NULL)))
typedef struct _Block4Data Block4Data;
typedef struct _MayaDaemonAddTimeoutData MayaDaemonAddTimeoutData;
#define _g_option_context_free0(var) ((var == NULL) ? NULL : (var = (g_option_context_free (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _MayaDaemon {
	GApplication parent_instance;
	MayaDaemonPrivate * priv;
};

struct _MayaDaemonClass {
	GApplicationClass parent_class;
};

struct _MayaDaemonPrivate {
	GeeHashMap* event_uid;
};

struct _Block1Data {
	int _ref_count_;
	MayaDaemon* self;
	ESource* source;
	GeeCollection* events;
};

struct _Block2Data {
	int _ref_count_;
	MayaDaemon* self;
	ESource* source;
	GeeCollection* events;
};

struct _Block3Data {
	int _ref_count_;
	MayaDaemon* self;
	ESource* source;
	GeeCollection* events;
};

struct _Block4Data {
	int _ref_count_;
	MayaDaemon* self;
	gchar* uid;
	ESource* source;
	ECalComponent* event;
	gpointer _async_data_;
};

struct _MayaDaemonAddTimeoutData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MayaDaemon* self;
	ESource* source;
	ECalComponent* event;
	guint interval;
	Block4Data* _data4_;
	gchar* _tmp0_;
	GeeHashMap* _tmp1_;
};

extern gboolean maya_has_debug;
gboolean maya_has_debug = FALSE;
static gint MayaDaemon_private_offset;
static gpointer maya_daemon_parent_class = NULL;

GType maya_daemon_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MayaDaemon, g_object_unref)
static void maya_daemon_real_activate (GApplication* base);
static void maya_daemon_load_today_events (MayaDaemon* self);
static void maya_daemon_on_events_added (MayaDaemon* self,
                                  ESource* source,
                                  GeeCollection* events);
static void _maya_daemon_on_events_added_maya_model_calendar_model_events_added (MayaModelCalendarModel* _sender,
                                                                          ESource* source,
                                                                          GeeCollection* events,
                                                                          gpointer self);
static void maya_daemon_on_events_updated (MayaDaemon* self,
                                    ESource* source,
                                    GeeCollection* events);
static void _maya_daemon_on_events_updated_maya_model_calendar_model_events_updated (MayaModelCalendarModel* _sender,
                                                                              ESource* source,
                                                                              GeeCollection* events,
                                                                              gpointer self);
static void maya_daemon_on_events_removed (MayaDaemon* self,
                                    ESource* source,
                                    GeeCollection* events);
static void _maya_daemon_on_events_removed_maya_model_calendar_model_events_removed (MayaModelCalendarModel* _sender,
                                                                              ESource* source,
                                                                              GeeCollection* events,
                                                                              gpointer self);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static gboolean __lambda4_ (Block1Data* _data1_);
static void maya_daemon_add_event (MayaDaemon* self,
                            ESource* source,
                            ECalComponent* event);
static gboolean ___lambda4__gsource_func (gpointer self);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gboolean __lambda6_ (Block2Data* _data2_);
static void maya_daemon_update_event (MayaDaemon* self,
                               ESource* source,
                               ECalComponent* event);
static gboolean ___lambda6__gsource_func (gpointer self);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static gboolean __lambda7_ (Block3Data* _data3_);
static void maya_daemon_remove_event (MayaDaemon* self,
                               ESource* source,
                               ECalComponent* event);
static gboolean ___lambda7__gsource_func (gpointer self);
static ECalComponentAlarmTrigger* _vala_ECalComponentAlarmTrigger_copy (ECalComponentAlarmTrigger* self);
static void _vala_ECalComponentAlarmTrigger_free (ECalComponentAlarmTrigger* self);
static void _vala_ECalComponentAlarm_free (ECalComponentAlarm* self);
static GTimeSpan maya_daemon_time_until_now (MayaDaemon* self,
                                      GDateTime* dt);
void maya_daemon_add_timeout (MayaDaemon* self,
                              ESource* source,
                              ECalComponent* event,
                              guint interval,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_);
void maya_daemon_add_timeout_finish (MayaDaemon* self,
                                     GAsyncResult* _res_);
static void _g_free0_ (gpointer var);
static inline void _g_slist_free__g_free0_ (GSList* self);
static void maya_daemon_add_timeout_data_free (gpointer _data);
static gboolean maya_daemon_add_timeout_co (MayaDaemonAddTimeoutData* _data_);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static gboolean __lambda5_ (Block4Data* _data4_);
void maya_daemon_queue_event_notification (MayaDaemon* self,
                                           ECalComponent* event,
                                           const gchar* uid);
static gboolean ___lambda5__gsource_func (gpointer self);
MayaDaemon* maya_daemon_new (void);
MayaDaemon* maya_daemon_construct (GType object_type);
static GObject * maya_daemon_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static gboolean _maya_daemon___lambda8_ (MayaDaemon* self);
static gboolean __maya_daemon___lambda8__gsource_func (gpointer self);
static void maya_daemon_finalize (GObject * obj);
gint maya_main (gchar** args,
                gint args_length1);

const GOptionEntry MAYA_options[2] = {{"debug", 'd', 0, G_OPTION_ARG_NONE, &maya_has_debug, N_ ("Print debug information"), NULL}, {NULL}};

static inline gpointer
maya_daemon_get_instance_private (MayaDaemon* self)
{
	return G_STRUCT_MEMBER_P (self, MayaDaemon_private_offset);
}

static void
maya_daemon_real_activate (GApplication* base)
{
	MayaDaemon * self;
#line 40 "../daemon/Daemon.vala"
	self = (MayaDaemon*) base;
#line 41 "../daemon/Daemon.vala"
	gtk_main ();
#line 226 "Daemon.c"
}

static void
_maya_daemon_on_events_added_maya_model_calendar_model_events_added (MayaModelCalendarModel* _sender,
                                                                     ESource* source,
                                                                     GeeCollection* events,
                                                                     gpointer self)
{
#line 47 "../daemon/Daemon.vala"
	maya_daemon_on_events_added ((MayaDaemon*) self, source, events);
#line 237 "Daemon.c"
}

static void
_maya_daemon_on_events_updated_maya_model_calendar_model_events_updated (MayaModelCalendarModel* _sender,
                                                                         ESource* source,
                                                                         GeeCollection* events,
                                                                         gpointer self)
{
#line 48 "../daemon/Daemon.vala"
	maya_daemon_on_events_updated ((MayaDaemon*) self, source, events);
#line 248 "Daemon.c"
}

static void
_maya_daemon_on_events_removed_maya_model_calendar_model_events_removed (MayaModelCalendarModel* _sender,
                                                                         ESource* source,
                                                                         GeeCollection* events,
                                                                         gpointer self)
{
#line 49 "../daemon/Daemon.vala"
	maya_daemon_on_events_removed ((MayaDaemon*) self, source, events);
#line 259 "Daemon.c"
}

static void
maya_daemon_load_today_events (MayaDaemon* self)
{
	GeeHashMap* _tmp0_;
	MayaModelCalendarModel* model = NULL;
	MayaModelCalendarModel* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	GDateTime* _tmp4_;
#line 44 "../daemon/Daemon.vala"
	g_return_if_fail (self != NULL);
#line 45 "../daemon/Daemon.vala"
	_tmp0_ = gee_hash_map_new (e_cal_component_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 45 "../daemon/Daemon.vala"
	_g_object_unref0 (self->priv->event_uid);
#line 45 "../daemon/Daemon.vala"
	self->priv->event_uid = _tmp0_;
#line 46 "../daemon/Daemon.vala"
	_tmp1_ = maya_model_calendar_model_get_default ();
#line 46 "../daemon/Daemon.vala"
	model = _tmp1_;
#line 47 "../daemon/Daemon.vala"
	g_signal_connect_object (model, "events-added", (GCallback) _maya_daemon_on_events_added_maya_model_calendar_model_events_added, self, 0);
#line 48 "../daemon/Daemon.vala"
	g_signal_connect_object (model, "events-updated", (GCallback) _maya_daemon_on_events_updated_maya_model_calendar_model_events_updated, self, 0);
#line 49 "../daemon/Daemon.vala"
	g_signal_connect_object (model, "events-removed", (GCallback) _maya_daemon_on_events_removed_maya_model_calendar_model_events_removed, self, 0);
#line 50 "../daemon/Daemon.vala"
	_tmp2_ = g_date_time_new_now_local ();
#line 50 "../daemon/Daemon.vala"
	_tmp3_ = maya_util_get_start_of_month (_tmp2_);
#line 50 "../daemon/Daemon.vala"
	_tmp4_ = _tmp3_;
#line 50 "../daemon/Daemon.vala"
	maya_model_calendar_model_set_month_start (model, _tmp4_);
#line 50 "../daemon/Daemon.vala"
	_g_date_time_unref0 (_tmp4_);
#line 44 "../daemon/Daemon.vala"
	_g_object_unref0 (model);
#line 301 "Daemon.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 53 "../daemon/Daemon.vala"
	return self ? g_object_ref (self) : NULL;
#line 309 "Daemon.c"
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
#line 53 "../daemon/Daemon.vala"
	g_atomic_int_inc (&_data1_->_ref_count_);
#line 53 "../daemon/Daemon.vala"
	return _data1_;
#line 319 "Daemon.c"
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
#line 53 "../daemon/Daemon.vala"
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
#line 329 "Daemon.c"
		MayaDaemon* self;
#line 53 "../daemon/Daemon.vala"
		self = _data1_->self;
#line 53 "../daemon/Daemon.vala"
		_g_object_unref0 (_data1_->source);
#line 53 "../daemon/Daemon.vala"
		_g_object_unref0 (_data1_->events);
#line 53 "../daemon/Daemon.vala"
		_g_object_unref0 (self);
#line 53 "../daemon/Daemon.vala"
		g_slice_free (Block1Data, _data1_);
#line 341 "Daemon.c"
	}
}

static gboolean
__lambda4_ (Block1Data* _data1_)
{
	MayaDaemon* self;
	gboolean result = FALSE;
#line 59 "../daemon/Daemon.vala"
	self = _data1_->self;
#line 352 "Daemon.c"
	{
		GeeIterator* _event_it = NULL;
		GeeIterator* _tmp0_;
#line 60 "../daemon/Daemon.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) _data1_->events);
#line 60 "../daemon/Daemon.vala"
		_event_it = _tmp0_;
#line 60 "../daemon/Daemon.vala"
		while (TRUE) {
#line 362 "Daemon.c"
			GeeIterator* _tmp1_;
			ECalComponent* event = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			ECalComponent* _tmp4_;
#line 60 "../daemon/Daemon.vala"
			_tmp1_ = _event_it;
#line 60 "../daemon/Daemon.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 60 "../daemon/Daemon.vala"
				break;
#line 374 "Daemon.c"
			}
#line 60 "../daemon/Daemon.vala"
			_tmp2_ = _event_it;
#line 60 "../daemon/Daemon.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 60 "../daemon/Daemon.vala"
			event = (ECalComponent*) _tmp3_;
#line 61 "../daemon/Daemon.vala"
			_tmp4_ = event;
#line 61 "../daemon/Daemon.vala"
			maya_daemon_add_event (self, _data1_->source, _tmp4_);
#line 60 "../daemon/Daemon.vala"
			_g_object_unref0 (event);
#line 388 "Daemon.c"
		}
#line 60 "../daemon/Daemon.vala"
		_g_object_unref0 (_event_it);
#line 392 "Daemon.c"
	}
#line 63 "../daemon/Daemon.vala"
	result = FALSE;
#line 63 "../daemon/Daemon.vala"
	return result;
#line 398 "Daemon.c"
}

static gboolean
___lambda4__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda4_ (self);
#line 59 "../daemon/Daemon.vala"
	return result;
#line 408 "Daemon.c"
}

static void
maya_daemon_on_events_added (MayaDaemon* self,
                             ESource* source,
                             GeeCollection* events)
{
	Block1Data* _data1_;
	ESource* _tmp0_;
	GeeCollection* _tmp1_;
	ESourceAlarms* extension = NULL;
	ESourceExtension* _tmp2_;
	ESourceAlarms* _tmp3_;
	ESourceAlarms* _tmp4_;
#line 53 "../daemon/Daemon.vala"
	g_return_if_fail (self != NULL);
#line 53 "../daemon/Daemon.vala"
	g_return_if_fail (source != NULL);
#line 53 "../daemon/Daemon.vala"
	g_return_if_fail (events != NULL);
#line 53 "../daemon/Daemon.vala"
	_data1_ = g_slice_new0 (Block1Data);
#line 53 "../daemon/Daemon.vala"
	_data1_->_ref_count_ = 1;
#line 53 "../daemon/Daemon.vala"
	_data1_->self = g_object_ref (self);
#line 53 "../daemon/Daemon.vala"
	_tmp0_ = _g_object_ref0 (source);
#line 53 "../daemon/Daemon.vala"
	_g_object_unref0 (_data1_->source);
#line 53 "../daemon/Daemon.vala"
	_data1_->source = _tmp0_;
#line 53 "../daemon/Daemon.vala"
	_tmp1_ = _g_object_ref0 (events);
#line 53 "../daemon/Daemon.vala"
	_g_object_unref0 (_data1_->events);
#line 53 "../daemon/Daemon.vala"
	_data1_->events = _tmp1_;
#line 54 "../daemon/Daemon.vala"
	_tmp2_ = e_source_get_extension (_data1_->source, E_SOURCE_EXTENSION_ALARMS);
#line 54 "../daemon/Daemon.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, e_source_alarms_get_type (), ESourceAlarms));
#line 54 "../daemon/Daemon.vala"
	extension = _tmp3_;
#line 55 "../daemon/Daemon.vala"
	_tmp4_ = extension;
#line 55 "../daemon/Daemon.vala"
	if (e_source_alarms_get_include_me (_tmp4_) == FALSE) {
#line 56 "../daemon/Daemon.vala"
		_g_object_unref0 (extension);
#line 56 "../daemon/Daemon.vala"
		block1_data_unref (_data1_);
#line 56 "../daemon/Daemon.vala"
		_data1_ = NULL;
#line 56 "../daemon/Daemon.vala"
		return;
#line 465 "Daemon.c"
	}
#line 59 "../daemon/Daemon.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda4__gsource_func, block1_data_ref (_data1_), block1_data_unref);
#line 53 "../daemon/Daemon.vala"
	_g_object_unref0 (extension);
#line 53 "../daemon/Daemon.vala"
	block1_data_unref (_data1_);
#line 53 "../daemon/Daemon.vala"
	_data1_ = NULL;
#line 475 "Daemon.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 67 "../daemon/Daemon.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 67 "../daemon/Daemon.vala"
	return _data2_;
#line 485 "Daemon.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 67 "../daemon/Daemon.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 495 "Daemon.c"
		MayaDaemon* self;
#line 67 "../daemon/Daemon.vala"
		self = _data2_->self;
#line 67 "../daemon/Daemon.vala"
		_g_object_unref0 (_data2_->source);
#line 67 "../daemon/Daemon.vala"
		_g_object_unref0 (_data2_->events);
#line 67 "../daemon/Daemon.vala"
		_g_object_unref0 (self);
#line 67 "../daemon/Daemon.vala"
		g_slice_free (Block2Data, _data2_);
#line 507 "Daemon.c"
	}
}

static gboolean
__lambda6_ (Block2Data* _data2_)
{
	MayaDaemon* self;
	gboolean result = FALSE;
#line 68 "../daemon/Daemon.vala"
	self = _data2_->self;
#line 518 "Daemon.c"
	{
		GeeIterator* _event_it = NULL;
		GeeIterator* _tmp0_;
#line 69 "../daemon/Daemon.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) _data2_->events);
#line 69 "../daemon/Daemon.vala"
		_event_it = _tmp0_;
#line 69 "../daemon/Daemon.vala"
		while (TRUE) {
#line 528 "Daemon.c"
			GeeIterator* _tmp1_;
			ECalComponent* event = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			ECalComponent* _tmp4_;
#line 69 "../daemon/Daemon.vala"
			_tmp1_ = _event_it;
#line 69 "../daemon/Daemon.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 69 "../daemon/Daemon.vala"
				break;
#line 540 "Daemon.c"
			}
#line 69 "../daemon/Daemon.vala"
			_tmp2_ = _event_it;
#line 69 "../daemon/Daemon.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 69 "../daemon/Daemon.vala"
			event = (ECalComponent*) _tmp3_;
#line 70 "../daemon/Daemon.vala"
			_tmp4_ = event;
#line 70 "../daemon/Daemon.vala"
			maya_daemon_update_event (self, _data2_->source, _tmp4_);
#line 69 "../daemon/Daemon.vala"
			_g_object_unref0 (event);
#line 554 "Daemon.c"
		}
#line 69 "../daemon/Daemon.vala"
		_g_object_unref0 (_event_it);
#line 558 "Daemon.c"
	}
#line 72 "../daemon/Daemon.vala"
	result = FALSE;
#line 72 "../daemon/Daemon.vala"
	return result;
#line 564 "Daemon.c"
}

static gboolean
___lambda6__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda6_ (self);
#line 68 "../daemon/Daemon.vala"
	return result;
#line 574 "Daemon.c"
}

static void
maya_daemon_on_events_updated (MayaDaemon* self,
                               ESource* source,
                               GeeCollection* events)
{
	Block2Data* _data2_;
	ESource* _tmp0_;
	GeeCollection* _tmp1_;
#line 67 "../daemon/Daemon.vala"
	g_return_if_fail (self != NULL);
#line 67 "../daemon/Daemon.vala"
	g_return_if_fail (source != NULL);
#line 67 "../daemon/Daemon.vala"
	g_return_if_fail (events != NULL);
#line 67 "../daemon/Daemon.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 67 "../daemon/Daemon.vala"
	_data2_->_ref_count_ = 1;
#line 67 "../daemon/Daemon.vala"
	_data2_->self = g_object_ref (self);
#line 67 "../daemon/Daemon.vala"
	_tmp0_ = _g_object_ref0 (source);
#line 67 "../daemon/Daemon.vala"
	_g_object_unref0 (_data2_->source);
#line 67 "../daemon/Daemon.vala"
	_data2_->source = _tmp0_;
#line 67 "../daemon/Daemon.vala"
	_tmp1_ = _g_object_ref0 (events);
#line 67 "../daemon/Daemon.vala"
	_g_object_unref0 (_data2_->events);
#line 67 "../daemon/Daemon.vala"
	_data2_->events = _tmp1_;
#line 68 "../daemon/Daemon.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda6__gsource_func, block2_data_ref (_data2_), block2_data_unref);
#line 67 "../daemon/Daemon.vala"
	block2_data_unref (_data2_);
#line 67 "../daemon/Daemon.vala"
	_data2_ = NULL;
#line 615 "Daemon.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 76 "../daemon/Daemon.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 76 "../daemon/Daemon.vala"
	return _data3_;
#line 625 "Daemon.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 76 "../daemon/Daemon.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 635 "Daemon.c"
		MayaDaemon* self;
#line 76 "../daemon/Daemon.vala"
		self = _data3_->self;
#line 76 "../daemon/Daemon.vala"
		_g_object_unref0 (_data3_->source);
#line 76 "../daemon/Daemon.vala"
		_g_object_unref0 (_data3_->events);
#line 76 "../daemon/Daemon.vala"
		_g_object_unref0 (self);
#line 76 "../daemon/Daemon.vala"
		g_slice_free (Block3Data, _data3_);
#line 647 "Daemon.c"
	}
}

static gboolean
__lambda7_ (Block3Data* _data3_)
{
	MayaDaemon* self;
	gboolean result = FALSE;
#line 77 "../daemon/Daemon.vala"
	self = _data3_->self;
#line 658 "Daemon.c"
	{
		GeeIterator* _event_it = NULL;
		GeeIterator* _tmp0_;
#line 78 "../daemon/Daemon.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) _data3_->events);
#line 78 "../daemon/Daemon.vala"
		_event_it = _tmp0_;
#line 78 "../daemon/Daemon.vala"
		while (TRUE) {
#line 668 "Daemon.c"
			GeeIterator* _tmp1_;
			ECalComponent* event = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			ECalComponent* _tmp4_;
#line 78 "../daemon/Daemon.vala"
			_tmp1_ = _event_it;
#line 78 "../daemon/Daemon.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 78 "../daemon/Daemon.vala"
				break;
#line 680 "Daemon.c"
			}
#line 78 "../daemon/Daemon.vala"
			_tmp2_ = _event_it;
#line 78 "../daemon/Daemon.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 78 "../daemon/Daemon.vala"
			event = (ECalComponent*) _tmp3_;
#line 79 "../daemon/Daemon.vala"
			_tmp4_ = event;
#line 79 "../daemon/Daemon.vala"
			maya_daemon_remove_event (self, _data3_->source, _tmp4_);
#line 78 "../daemon/Daemon.vala"
			_g_object_unref0 (event);
#line 694 "Daemon.c"
		}
#line 78 "../daemon/Daemon.vala"
		_g_object_unref0 (_event_it);
#line 698 "Daemon.c"
	}
#line 81 "../daemon/Daemon.vala"
	result = FALSE;
#line 81 "../daemon/Daemon.vala"
	return result;
#line 704 "Daemon.c"
}

static gboolean
___lambda7__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda7_ (self);
#line 77 "../daemon/Daemon.vala"
	return result;
#line 714 "Daemon.c"
}

static void
maya_daemon_on_events_removed (MayaDaemon* self,
                               ESource* source,
                               GeeCollection* events)
{
	Block3Data* _data3_;
	ESource* _tmp0_;
	GeeCollection* _tmp1_;
#line 76 "../daemon/Daemon.vala"
	g_return_if_fail (self != NULL);
#line 76 "../daemon/Daemon.vala"
	g_return_if_fail (source != NULL);
#line 76 "../daemon/Daemon.vala"
	g_return_if_fail (events != NULL);
#line 76 "../daemon/Daemon.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 76 "../daemon/Daemon.vala"
	_data3_->_ref_count_ = 1;
#line 76 "../daemon/Daemon.vala"
	_data3_->self = g_object_ref (self);
#line 76 "../daemon/Daemon.vala"
	_tmp0_ = _g_object_ref0 (source);
#line 76 "../daemon/Daemon.vala"
	_g_object_unref0 (_data3_->source);
#line 76 "../daemon/Daemon.vala"
	_data3_->source = _tmp0_;
#line 76 "../daemon/Daemon.vala"
	_tmp1_ = _g_object_ref0 (events);
#line 76 "../daemon/Daemon.vala"
	_g_object_unref0 (_data3_->events);
#line 76 "../daemon/Daemon.vala"
	_data3_->events = _tmp1_;
#line 77 "../daemon/Daemon.vala"
	g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ___lambda7__gsource_func, block3_data_ref (_data3_), block3_data_unref);
#line 76 "../daemon/Daemon.vala"
	block3_data_unref (_data3_);
#line 76 "../daemon/Daemon.vala"
	_data3_ = NULL;
#line 755 "Daemon.c"
}

static ECalComponentAlarmTrigger*
_vala_ECalComponentAlarmTrigger_copy (ECalComponentAlarmTrigger* self)
{
#line 101 "../daemon/Daemon.vala"
	return g_boxed_copy (e_cal_component_alarm_trigger_get_type (), self);
#line 763 "Daemon.c"
}

static gpointer
__vala_ECalComponentAlarmTrigger_copy0 (gpointer self)
{
#line 101 "../daemon/Daemon.vala"
	return self ? _vala_ECalComponentAlarmTrigger_copy (self) : NULL;
#line 771 "Daemon.c"
}

static void
_vala_ECalComponentAlarmTrigger_free (ECalComponentAlarmTrigger* self)
{
#line 101 "../daemon/Daemon.vala"
	g_boxed_free (e_cal_component_alarm_trigger_get_type (), self);
#line 779 "Daemon.c"
}

static void
_vala_ECalComponentAlarm_free (ECalComponentAlarm* self)
{
#line 110 "../daemon/Daemon.vala"
	g_boxed_free (e_cal_component_alarm_get_type (), self);
#line 787 "Daemon.c"
}

static void
_g_free0_ (gpointer var)
{
#line 88 "../daemon/Daemon.vala"
	var = (g_free (var), NULL);
#line 795 "Daemon.c"
}

static inline void
_g_slist_free__g_free0_ (GSList* self)
{
#line 88 "../daemon/Daemon.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_free0_);
#line 803 "Daemon.c"
}

static void
maya_daemon_add_event (MayaDaemon* self,
                       ESource* source,
                       ECalComponent* event)
{
	ICalComponent* comp = NULL;
	ICalComponent* _tmp0_;
	ICalComponent* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	ICalComponent* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GSList* _tmp9_;
#line 85 "../daemon/Daemon.vala"
	g_return_if_fail (self != NULL);
#line 85 "../daemon/Daemon.vala"
	g_return_if_fail (source != NULL);
#line 85 "../daemon/Daemon.vala"
	g_return_if_fail (event != NULL);
#line 86 "../daemon/Daemon.vala"
	_tmp0_ = e_cal_component_get_icalcomponent (event);
#line 86 "../daemon/Daemon.vala"
	comp = _tmp0_;
#line 87 "../daemon/Daemon.vala"
	_tmp1_ = comp;
#line 87 "../daemon/Daemon.vala"
	_tmp2_ = i_cal_component_get_summary (_tmp1_);
#line 87 "../daemon/Daemon.vala"
	_tmp3_ = e_source_dup_display_name (source);
#line 87 "../daemon/Daemon.vala"
	_tmp4_ = _tmp3_;
#line 87 "../daemon/Daemon.vala"
	_tmp5_ = comp;
#line 87 "../daemon/Daemon.vala"
	_tmp6_ = i_cal_component_get_uid (_tmp5_);
#line 87 "../daemon/Daemon.vala"
	_tmp7_ = g_strdup_printf ("Event [%s, %s, %s]", _tmp2_, _tmp4_, _tmp6_);
#line 87 "../daemon/Daemon.vala"
	_tmp8_ = _tmp7_;
#line 87 "../daemon/Daemon.vala"
	g_debug ("Daemon.vala:87: %s", _tmp8_);
#line 87 "../daemon/Daemon.vala"
	_g_free0 (_tmp8_);
#line 87 "../daemon/Daemon.vala"
	_g_free0 (_tmp4_);
#line 88 "../daemon/Daemon.vala"
	_tmp9_ = e_cal_component_get_alarm_uids (event);
#line 856 "Daemon.c"
	{
		GSList* alarm_uid_collection = NULL;
		GSList* alarm_uid_it = NULL;
#line 88 "../daemon/Daemon.vala"
		alarm_uid_collection = _tmp9_;
#line 88 "../daemon/Daemon.vala"
		for (alarm_uid_it = alarm_uid_collection; alarm_uid_it != NULL; alarm_uid_it = alarm_uid_it->next) {
#line 864 "Daemon.c"
			gchar* _tmp10_;
			gchar* alarm_uid = NULL;
#line 88 "../daemon/Daemon.vala"
			_tmp10_ = g_strdup ((const gchar*) alarm_uid_it->data);
#line 88 "../daemon/Daemon.vala"
			alarm_uid = _tmp10_;
#line 871 "Daemon.c"
			{
				ECalComponentAlarm* e_alarm = NULL;
				const gchar* _tmp11_;
				ECalComponentAlarm* _tmp12_;
				ECalComponentAlarmAction action = 0;
				ECalComponentAlarm* _tmp13_;
				ECalComponentAlarmAction _tmp14_;
#line 89 "../daemon/Daemon.vala"
				_tmp11_ = alarm_uid;
#line 89 "../daemon/Daemon.vala"
				_tmp12_ = e_cal_component_get_alarm (event, _tmp11_);
#line 89 "../daemon/Daemon.vala"
				e_alarm = _tmp12_;
#line 93 "../daemon/Daemon.vala"
				_tmp13_ = e_alarm;
#line 93 "../daemon/Daemon.vala"
				action = e_cal_component_alarm_get_action (_tmp13_);
#line 97 "../daemon/Daemon.vala"
				_tmp14_ = action;
#line 97 "../daemon/Daemon.vala"
				switch (_tmp14_) {
#line 97 "../daemon/Daemon.vala"
					case E_CAL_COMPONENT_ALARM_DISPLAY:
#line 895 "Daemon.c"
					{
						ECalComponentAlarmTrigger* trigger = NULL;
						ECalComponentAlarm* _tmp15_;
						ECalComponentAlarmTrigger* _tmp16_;
						ECalComponentAlarmTrigger* _tmp17_;
						ECalComponentAlarmTrigger* _tmp18_;
#line 101 "../daemon/Daemon.vala"
						_tmp15_ = e_alarm;
#line 101 "../daemon/Daemon.vala"
						_tmp16_ = e_cal_component_alarm_get_trigger (_tmp15_);
#line 101 "../daemon/Daemon.vala"
						_tmp17_ = __vala_ECalComponentAlarmTrigger_copy0 (_tmp16_);
#line 101 "../daemon/Daemon.vala"
						__vala_ECalComponentAlarmTrigger_free0 (trigger);
#line 101 "../daemon/Daemon.vala"
						trigger = _tmp17_;
#line 105 "../daemon/Daemon.vala"
						_tmp18_ = trigger;
#line 105 "../daemon/Daemon.vala"
						if (e_cal_component_alarm_trigger_get_kind (_tmp18_) == E_CAL_COMPONENT_ALARM_TRIGGER_RELATIVE_START) {
#line 916 "Daemon.c"
							ICalDuration* duration = NULL;
							ECalComponentAlarmTrigger* _tmp19_;
							ICalDuration* _tmp20_;
							ICalDuration* _tmp21_;
							GDateTime* start_time = NULL;
							ICalComponent* _tmp22_;
							ICalTime* _tmp23_;
							ICalTime* _tmp24_;
							GDateTime* _tmp25_;
							GDateTime* _tmp26_;
							GDateTime* now = NULL;
							GDateTime* _tmp27_;
							GDateTime* _tmp28_;
							GDateTime* _tmp29_;
							GDateTime* _tmp30_;
							ICalDuration* _tmp31_;
							GDateTime* _tmp32_;
							GDateTime* _tmp33_;
							ICalDuration* _tmp34_;
							GDateTime* _tmp35_;
							GDateTime* _tmp36_;
							ICalDuration* _tmp37_;
							GDateTime* _tmp38_;
							GDateTime* _tmp39_;
							ICalDuration* _tmp40_;
							GDateTime* _tmp41_;
							GDateTime* _tmp42_;
							ICalDuration* _tmp43_;
							GDateTime* _tmp44_;
							gboolean _tmp45_ = FALSE;
							GDateTime* _tmp46_;
							GDateTime* _tmp47_;
#line 106 "../daemon/Daemon.vala"
							_tmp19_ = trigger;
#line 106 "../daemon/Daemon.vala"
							_tmp20_ = e_cal_component_alarm_trigger_get_duration (_tmp19_);
#line 106 "../daemon/Daemon.vala"
							_tmp21_ = _g_object_ref0 (_tmp20_);
#line 106 "../daemon/Daemon.vala"
							duration = _tmp21_;
#line 107 "../daemon/Daemon.vala"
							_tmp22_ = comp;
#line 107 "../daemon/Daemon.vala"
							_tmp23_ = i_cal_component_get_dtstart (_tmp22_);
#line 107 "../daemon/Daemon.vala"
							_tmp24_ = _tmp23_;
#line 107 "../daemon/Daemon.vala"
							_tmp25_ = maya_util_ical_to_date_time (_tmp24_);
#line 107 "../daemon/Daemon.vala"
							_tmp26_ = _tmp25_;
#line 107 "../daemon/Daemon.vala"
							_g_object_unref0 (_tmp24_);
#line 107 "../daemon/Daemon.vala"
							start_time = _tmp26_;
#line 108 "../daemon/Daemon.vala"
							_tmp27_ = g_date_time_new_now_local ();
#line 108 "../daemon/Daemon.vala"
							now = _tmp27_;
#line 109 "../daemon/Daemon.vala"
							_tmp28_ = now;
#line 109 "../daemon/Daemon.vala"
							_tmp29_ = start_time;
#line 109 "../daemon/Daemon.vala"
							if (g_date_time_compare (_tmp28_, _tmp29_) > 0) {
#line 110 "../daemon/Daemon.vala"
								_g_date_time_unref0 (now);
#line 110 "../daemon/Daemon.vala"
								_g_date_time_unref0 (start_time);
#line 110 "../daemon/Daemon.vala"
								_g_object_unref0 (duration);
#line 110 "../daemon/Daemon.vala"
								__vala_ECalComponentAlarmTrigger_free0 (trigger);
#line 110 "../daemon/Daemon.vala"
								__vala_ECalComponentAlarm_free0 (e_alarm);
#line 110 "../daemon/Daemon.vala"
								_g_free0 (alarm_uid);
#line 110 "../daemon/Daemon.vala"
								continue;
#line 995 "Daemon.c"
							}
#line 112 "../daemon/Daemon.vala"
							_tmp30_ = start_time;
#line 112 "../daemon/Daemon.vala"
							_tmp31_ = duration;
#line 112 "../daemon/Daemon.vala"
							_tmp32_ = g_date_time_add_weeks (_tmp30_, -((gint) i_cal_duration_get_weeks (_tmp31_)));
#line 112 "../daemon/Daemon.vala"
							_g_date_time_unref0 (start_time);
#line 112 "../daemon/Daemon.vala"
							start_time = _tmp32_;
#line 113 "../daemon/Daemon.vala"
							_tmp33_ = start_time;
#line 113 "../daemon/Daemon.vala"
							_tmp34_ = duration;
#line 113 "../daemon/Daemon.vala"
							_tmp35_ = g_date_time_add_days (_tmp33_, -((gint) i_cal_duration_get_days (_tmp34_)));
#line 113 "../daemon/Daemon.vala"
							_g_date_time_unref0 (start_time);
#line 113 "../daemon/Daemon.vala"
							start_time = _tmp35_;
#line 114 "../daemon/Daemon.vala"
							_tmp36_ = start_time;
#line 114 "../daemon/Daemon.vala"
							_tmp37_ = duration;
#line 114 "../daemon/Daemon.vala"
							_tmp38_ = g_date_time_add_hours (_tmp36_, -((gint) i_cal_duration_get_hours (_tmp37_)));
#line 114 "../daemon/Daemon.vala"
							_g_date_time_unref0 (start_time);
#line 114 "../daemon/Daemon.vala"
							start_time = _tmp38_;
#line 115 "../daemon/Daemon.vala"
							_tmp39_ = start_time;
#line 115 "../daemon/Daemon.vala"
							_tmp40_ = duration;
#line 115 "../daemon/Daemon.vala"
							_tmp41_ = g_date_time_add_minutes (_tmp39_, -((gint) i_cal_duration_get_minutes (_tmp40_)));
#line 115 "../daemon/Daemon.vala"
							_g_date_time_unref0 (start_time);
#line 115 "../daemon/Daemon.vala"
							start_time = _tmp41_;
#line 116 "../daemon/Daemon.vala"
							_tmp42_ = start_time;
#line 116 "../daemon/Daemon.vala"
							_tmp43_ = duration;
#line 116 "../daemon/Daemon.vala"
							_tmp44_ = g_date_time_add_seconds (_tmp42_, (gdouble) (-((gint) i_cal_duration_get_seconds (_tmp43_))));
#line 116 "../daemon/Daemon.vala"
							_g_date_time_unref0 (start_time);
#line 116 "../daemon/Daemon.vala"
							start_time = _tmp44_;
#line 117 "../daemon/Daemon.vala"
							_tmp46_ = start_time;
#line 117 "../daemon/Daemon.vala"
							_tmp47_ = now;
#line 117 "../daemon/Daemon.vala"
							if (g_date_time_get_year (_tmp46_) == g_date_time_get_year (_tmp47_)) {
#line 1053 "Daemon.c"
								GDateTime* _tmp48_;
								GDateTime* _tmp49_;
#line 117 "../daemon/Daemon.vala"
								_tmp48_ = start_time;
#line 117 "../daemon/Daemon.vala"
								_tmp49_ = now;
#line 117 "../daemon/Daemon.vala"
								_tmp45_ = g_date_time_get_day_of_year (_tmp48_) == g_date_time_get_day_of_year (_tmp49_);
#line 1062 "Daemon.c"
							} else {
#line 117 "../daemon/Daemon.vala"
								_tmp45_ = FALSE;
#line 1066 "Daemon.c"
							}
#line 117 "../daemon/Daemon.vala"
							if (_tmp45_) {
#line 1070 "Daemon.c"
								GTimeSpan time = 0LL;
								GDateTime* _tmp50_;
#line 118 "../daemon/Daemon.vala"
								_tmp50_ = start_time;
#line 118 "../daemon/Daemon.vala"
								time = maya_daemon_time_until_now (self, _tmp50_);
#line 119 "../daemon/Daemon.vala"
								if (time >= ((GTimeSpan) 0)) {
#line 120 "../daemon/Daemon.vala"
									maya_daemon_add_timeout (self, source, event, (guint) time, NULL, NULL);
#line 1081 "Daemon.c"
								}
							}
#line 105 "../daemon/Daemon.vala"
							_g_date_time_unref0 (now);
#line 105 "../daemon/Daemon.vala"
							_g_date_time_unref0 (start_time);
#line 105 "../daemon/Daemon.vala"
							_g_object_unref0 (duration);
#line 1090 "Daemon.c"
						}
#line 124 "../daemon/Daemon.vala"
						__vala_ECalComponentAlarmTrigger_free0 (trigger);
#line 124 "../daemon/Daemon.vala"
						__vala_ECalComponentAlarm_free0 (e_alarm);
#line 124 "../daemon/Daemon.vala"
						_g_free0 (alarm_uid);
#line 124 "../daemon/Daemon.vala"
						continue;
#line 1100 "Daemon.c"
					}
					default:
					{
#line 126 "../daemon/Daemon.vala"
						__vala_ECalComponentAlarm_free0 (e_alarm);
#line 126 "../daemon/Daemon.vala"
						_g_free0 (alarm_uid);
#line 126 "../daemon/Daemon.vala"
						continue;
#line 1110 "Daemon.c"
					}
				}
#line 88 "../daemon/Daemon.vala"
				__vala_ECalComponentAlarm_free0 (e_alarm);
#line 88 "../daemon/Daemon.vala"
				_g_free0 (alarm_uid);
#line 1117 "Daemon.c"
			}
		}
#line 88 "../daemon/Daemon.vala"
		(alarm_uid_collection == NULL) ? NULL : (alarm_uid_collection = (_g_slist_free__g_free0_ (alarm_uid_collection), NULL));
#line 1122 "Daemon.c"
	}
}

static void
maya_daemon_add_timeout_data_free (gpointer _data)
{
	MayaDaemonAddTimeoutData* _data_;
	_data_ = _data;
#line 28 "../daemon/Daemon.vala"
	_g_object_unref0 (_data_->self);
#line 28 "../daemon/Daemon.vala"
	g_slice_free (MayaDaemonAddTimeoutData, _data_);
#line 1135 "Daemon.c"
}

void
maya_daemon_add_timeout (MayaDaemon* self,
                         ESource* source,
                         ECalComponent* event,
                         guint interval,
                         GAsyncReadyCallback _callback_,
                         gpointer _user_data_)
{
	MayaDaemonAddTimeoutData* _data_;
	MayaDaemon* _tmp0_;
	ESource* _tmp1_;
	ECalComponent* _tmp2_;
#line 28 "../daemon/Daemon.vala"
	_data_ = g_slice_new0 (MayaDaemonAddTimeoutData);
#line 28 "../daemon/Daemon.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 28 "../daemon/Daemon.vala"
	g_task_set_task_data (_data_->_async_result, _data_, maya_daemon_add_timeout_data_free);
#line 28 "../daemon/Daemon.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 28 "../daemon/Daemon.vala"
	_data_->self = _tmp0_;
#line 28 "../daemon/Daemon.vala"
	_tmp1_ = _g_object_ref0 (source);
#line 28 "../daemon/Daemon.vala"
	_g_object_unref0 (_data_->source);
#line 28 "../daemon/Daemon.vala"
	_data_->source = _tmp1_;
#line 28 "../daemon/Daemon.vala"
	_tmp2_ = _g_object_ref0 (event);
#line 28 "../daemon/Daemon.vala"
	_g_object_unref0 (_data_->event);
#line 28 "../daemon/Daemon.vala"
	_data_->event = _tmp2_;
#line 28 "../daemon/Daemon.vala"
	_data_->interval = interval;
#line 28 "../daemon/Daemon.vala"
	maya_daemon_add_timeout_co (_data_);
#line 1176 "Daemon.c"
}

void
maya_daemon_add_timeout_finish (MayaDaemon* self,
                                GAsyncResult* _res_)
{
	MayaDaemonAddTimeoutData* _data_;
#line 28 "../daemon/Daemon.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 1186 "Daemon.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 131 "../daemon/Daemon.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 131 "../daemon/Daemon.vala"
	return _data4_;
#line 1196 "Daemon.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 131 "../daemon/Daemon.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 1206 "Daemon.c"
		MayaDaemon* self;
#line 131 "../daemon/Daemon.vala"
		self = _data4_->self;
#line 131 "../daemon/Daemon.vala"
		_g_free0 (_data4_->uid);
#line 131 "../daemon/Daemon.vala"
		_g_object_unref0 (_data4_->source);
#line 131 "../daemon/Daemon.vala"
		_g_object_unref0 (_data4_->event);
#line 131 "../daemon/Daemon.vala"
		_g_object_unref0 (self);
#line 131 "../daemon/Daemon.vala"
		g_slice_free (Block4Data, _data4_);
#line 1220 "Daemon.c"
	}
}

static gchar*
g_date_time_to_string (GDateTime* self)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 3049 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 3050 "glib-2.0.vapi"
	_tmp0_ = g_date_time_format (self, "%FT%H:%M:%S%z");
#line 3050 "glib-2.0.vapi"
	result = _tmp0_;
#line 3050 "glib-2.0.vapi"
	return result;
#line 1237 "Daemon.c"
}

static gboolean
__lambda5_ (Block4Data* _data4_)
{
	MayaDaemon* self;
	gboolean result = FALSE;
	ESourceAlarms* extension = NULL;
	ESourceExtension* _tmp0_;
	ESourceAlarms* _tmp1_;
	ESourceAlarms* _tmp2_;
#line 135 "../daemon/Daemon.vala"
	self = _data4_->self;
#line 136 "../daemon/Daemon.vala"
	_tmp0_ = e_source_get_extension (_data4_->source, E_SOURCE_EXTENSION_ALARMS);
#line 136 "../daemon/Daemon.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, e_source_alarms_get_type (), ESourceAlarms));
#line 136 "../daemon/Daemon.vala"
	extension = _tmp1_;
#line 137 "../daemon/Daemon.vala"
	_tmp2_ = extension;
#line 137 "../daemon/Daemon.vala"
	if (_tmp2_ != NULL) {
#line 1261 "Daemon.c"
		ESourceAlarms* _tmp3_;
		GDateTime* _tmp4_;
		GDateTime* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 138 "../daemon/Daemon.vala"
		_tmp3_ = extension;
#line 138 "../daemon/Daemon.vala"
		_tmp4_ = g_date_time_new_now_local ();
#line 138 "../daemon/Daemon.vala"
		_tmp5_ = _tmp4_;
#line 138 "../daemon/Daemon.vala"
		_tmp6_ = g_date_time_to_string (_tmp5_);
#line 138 "../daemon/Daemon.vala"
		_tmp7_ = _tmp6_;
#line 138 "../daemon/Daemon.vala"
		e_source_alarms_set_last_notified (_tmp3_, _tmp7_);
#line 138 "../daemon/Daemon.vala"
		_g_free0 (_tmp7_);
#line 138 "../daemon/Daemon.vala"
		_g_date_time_unref0 (_tmp5_);
#line 1283 "Daemon.c"
	}
#line 141 "../daemon/Daemon.vala"
	maya_daemon_queue_event_notification (self, _data4_->event, _data4_->uid);
#line 142 "../daemon/Daemon.vala"
	result = FALSE;
#line 142 "../daemon/Daemon.vala"
	_g_object_unref0 (extension);
#line 142 "../daemon/Daemon.vala"
	return result;
#line 1293 "Daemon.c"
}

static gboolean
___lambda5__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda5_ (self);
#line 135 "../daemon/Daemon.vala"
	return result;
#line 1303 "Daemon.c"
}

static gboolean
maya_daemon_add_timeout_co (MayaDaemonAddTimeoutData* _data_)
{
#line 131 "../daemon/Daemon.vala"
	switch (_data_->_state_) {
#line 131 "../daemon/Daemon.vala"
		case 0:
#line 1313 "Daemon.c"
		goto _state_0;
		default:
#line 131 "../daemon/Daemon.vala"
		g_assert_not_reached ();
#line 1318 "Daemon.c"
	}
	_state_0:
#line 131 "../daemon/Daemon.vala"
	_data_->_data4_ = g_slice_new0 (Block4Data);
#line 131 "../daemon/Daemon.vala"
	_data_->_data4_->_ref_count_ = 1;
#line 131 "../daemon/Daemon.vala"
	_data_->_data4_->self = g_object_ref (_data_->self);
#line 131 "../daemon/Daemon.vala"
	_g_object_unref0 (_data_->_data4_->source);
#line 131 "../daemon/Daemon.vala"
	_data_->_data4_->source = _data_->source;
#line 131 "../daemon/Daemon.vala"
	_g_object_unref0 (_data_->_data4_->event);
#line 131 "../daemon/Daemon.vala"
	_data_->_data4_->event = _data_->event;
#line 131 "../daemon/Daemon.vala"
	_data_->_data4_->_async_data_ = _data_;
#line 132 "../daemon/Daemon.vala"
	_data_->_tmp0_ = g_strdup_printf ("%u-%u", _data_->interval, (guint) g_random_int ());
#line 132 "../daemon/Daemon.vala"
	_data_->_data4_->uid = _data_->_tmp0_;
#line 133 "../daemon/Daemon.vala"
	_data_->_tmp1_ = _data_->self->priv->event_uid;
#line 133 "../daemon/Daemon.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->_tmp1_, _data_->_data4_->event, _data_->_data4_->uid);
#line 134 "../daemon/Daemon.vala"
	g_debug ("Daemon.vala:134: adding timeout uid:%s", _data_->_data4_->uid);
#line 135 "../daemon/Daemon.vala"
	g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, _data_->interval, ___lambda5__gsource_func, block4_data_ref (_data_->_data4_), block4_data_unref);
#line 131 "../daemon/Daemon.vala"
	block4_data_unref (_data_->_data4_);
#line 131 "../daemon/Daemon.vala"
	_data_->_data4_ = NULL;
#line 131 "../daemon/Daemon.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 131 "../daemon/Daemon.vala"
	if (_data_->_state_ != 0) {
#line 131 "../daemon/Daemon.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 131 "../daemon/Daemon.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1361 "Daemon.c"
		}
	}
#line 131 "../daemon/Daemon.vala"
	g_object_unref (_data_->_async_result);
#line 131 "../daemon/Daemon.vala"
	return FALSE;
#line 1368 "Daemon.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1477 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1477 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1477 "glib-2.0.vapi"
	return result;
#line 1387 "Daemon.c"
}

void
maya_daemon_queue_event_notification (MayaDaemon* self,
                                      ECalComponent* event,
                                      const gchar* uid)
{
	GeeHashMap* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	gboolean _tmp4_;
	ICalComponent* comp = NULL;
	ICalComponent* _tmp5_;
	gchar* primary_text = NULL;
	ICalComponent* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	GDateTime* start_time = NULL;
	ICalComponent* _tmp9_;
	ICalTime* _tmp10_;
	ICalTime* _tmp11_;
	GDateTime* _tmp12_;
	GDateTime* _tmp13_;
	GDateTime* now = NULL;
	GDateTime* _tmp14_;
	gchar* secondary_text = NULL;
	gchar* _tmp15_;
	GSettings* h24_settings = NULL;
	GSettings* _tmp16_;
	gchar* format = NULL;
	GSettings* _tmp17_;
	gchar* _tmp18_;
	gchar* text = NULL;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	GDateTime* _tmp21_;
	GDateTime* _tmp22_;
	GNotification* notification = NULL;
	const gchar* _tmp41_;
	GNotification* _tmp42_;
	GNotification* _tmp43_;
	const gchar* _tmp44_;
	GNotification* _tmp45_;
	GThemedIcon* _tmp46_;
	GThemedIcon* _tmp47_;
	GApplication* _tmp48_;
	GNotification* _tmp49_;
#line 146 "../daemon/Daemon.vala"
	g_return_if_fail (self != NULL);
#line 146 "../daemon/Daemon.vala"
	g_return_if_fail (event != NULL);
#line 146 "../daemon/Daemon.vala"
	g_return_if_fail (uid != NULL);
#line 147 "../daemon/Daemon.vala"
	_tmp0_ = self->priv->event_uid;
#line 147 "../daemon/Daemon.vala"
	_tmp1_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp0_);
#line 147 "../daemon/Daemon.vala"
	_tmp2_ = _tmp1_;
#line 147 "../daemon/Daemon.vala"
	_tmp3_ = _tmp2_;
#line 147 "../daemon/Daemon.vala"
	_tmp4_ = gee_collection_contains (_tmp3_, uid) == FALSE;
#line 147 "../daemon/Daemon.vala"
	_g_object_unref0 (_tmp3_);
#line 147 "../daemon/Daemon.vala"
	if (_tmp4_) {
#line 148 "../daemon/Daemon.vala"
		return;
#line 1458 "Daemon.c"
	}
#line 151 "../daemon/Daemon.vala"
	_tmp5_ = e_cal_component_get_icalcomponent (event);
#line 151 "../daemon/Daemon.vala"
	comp = _tmp5_;
#line 152 "../daemon/Daemon.vala"
	_tmp6_ = comp;
#line 152 "../daemon/Daemon.vala"
	_tmp7_ = i_cal_component_get_summary (_tmp6_);
#line 152 "../daemon/Daemon.vala"
	_tmp8_ = g_strdup_printf ("%s", _tmp7_);
#line 152 "../daemon/Daemon.vala"
	primary_text = _tmp8_;
#line 153 "../daemon/Daemon.vala"
	_tmp9_ = comp;
#line 153 "../daemon/Daemon.vala"
	_tmp10_ = i_cal_component_get_dtstart (_tmp9_);
#line 153 "../daemon/Daemon.vala"
	_tmp11_ = _tmp10_;
#line 153 "../daemon/Daemon.vala"
	_tmp12_ = maya_util_ical_to_date_time (_tmp11_);
#line 153 "../daemon/Daemon.vala"
	_tmp13_ = _tmp12_;
#line 153 "../daemon/Daemon.vala"
	_g_object_unref0 (_tmp11_);
#line 153 "../daemon/Daemon.vala"
	start_time = _tmp13_;
#line 154 "../daemon/Daemon.vala"
	_tmp14_ = g_date_time_new_now_local ();
#line 154 "../daemon/Daemon.vala"
	now = _tmp14_;
#line 155 "../daemon/Daemon.vala"
	_tmp15_ = g_strdup ("");
#line 155 "../daemon/Daemon.vala"
	secondary_text = _tmp15_;
#line 156 "../daemon/Daemon.vala"
	_tmp16_ = g_settings_new ("org.gnome.desktop.interface");
#line 156 "../daemon/Daemon.vala"
	h24_settings = _tmp16_;
#line 157 "../daemon/Daemon.vala"
	_tmp17_ = h24_settings;
#line 157 "../daemon/Daemon.vala"
	_tmp18_ = g_settings_get_string (_tmp17_, "clock-format");
#line 157 "../daemon/Daemon.vala"
	format = _tmp18_;
#line 158 "../daemon/Daemon.vala"
	_tmp19_ = format;
#line 158 "../daemon/Daemon.vala"
	_tmp20_ = granite_date_time_get_default_time_format (string_contains (_tmp19_, "12h"), FALSE);
#line 158 "../daemon/Daemon.vala"
	text = _tmp20_;
#line 159 "../daemon/Daemon.vala"
	_tmp21_ = start_time;
#line 159 "../daemon/Daemon.vala"
	_tmp22_ = now;
#line 159 "../daemon/Daemon.vala"
	if (g_date_time_get_year (_tmp21_) == g_date_time_get_year (_tmp22_)) {
#line 1516 "Daemon.c"
		GDateTime* _tmp23_;
		GDateTime* _tmp24_;
#line 160 "../daemon/Daemon.vala"
		_tmp23_ = start_time;
#line 160 "../daemon/Daemon.vala"
		_tmp24_ = now;
#line 160 "../daemon/Daemon.vala"
		if (g_date_time_get_day_of_year (_tmp23_) == g_date_time_get_day_of_year (_tmp24_)) {
#line 1525 "Daemon.c"
			GDateTime* _tmp25_;
			gchar* _tmp26_;
#line 161 "../daemon/Daemon.vala"
			_tmp25_ = start_time;
#line 161 "../daemon/Daemon.vala"
			_tmp26_ = granite_date_time_get_relative_datetime (_tmp25_);
#line 161 "../daemon/Daemon.vala"
			_g_free0 (secondary_text);
#line 161 "../daemon/Daemon.vala"
			secondary_text = _tmp26_;
#line 1536 "Daemon.c"
		} else {
			GDateTime* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			const gchar* _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
			gchar* _tmp33_;
#line 163 "../daemon/Daemon.vala"
			_tmp27_ = start_time;
#line 163 "../daemon/Daemon.vala"
			_tmp28_ = granite_date_time_get_default_date_format (FALSE, TRUE, FALSE);
#line 163 "../daemon/Daemon.vala"
			_tmp29_ = _tmp28_;
#line 163 "../daemon/Daemon.vala"
			_tmp30_ = text;
#line 163 "../daemon/Daemon.vala"
			_tmp31_ = g_strdup_printf ("%s, %s", _tmp29_, _tmp30_);
#line 163 "../daemon/Daemon.vala"
			_tmp32_ = _tmp31_;
#line 163 "../daemon/Daemon.vala"
			_tmp33_ = g_date_time_format (_tmp27_, _tmp32_);
#line 163 "../daemon/Daemon.vala"
			_g_free0 (secondary_text);
#line 163 "../daemon/Daemon.vala"
			secondary_text = _tmp33_;
#line 163 "../daemon/Daemon.vala"
			_g_free0 (_tmp32_);
#line 163 "../daemon/Daemon.vala"
			_g_free0 (_tmp29_);
#line 1567 "Daemon.c"
		}
	} else {
		GDateTime* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		const gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_;
#line 166 "../daemon/Daemon.vala"
		_tmp34_ = start_time;
#line 166 "../daemon/Daemon.vala"
		_tmp35_ = granite_date_time_get_default_date_format (FALSE, TRUE, TRUE);
#line 166 "../daemon/Daemon.vala"
		_tmp36_ = _tmp35_;
#line 166 "../daemon/Daemon.vala"
		_tmp37_ = text;
#line 166 "../daemon/Daemon.vala"
		_tmp38_ = g_strdup_printf ("%s, %s", _tmp36_, _tmp37_);
#line 166 "../daemon/Daemon.vala"
		_tmp39_ = _tmp38_;
#line 166 "../daemon/Daemon.vala"
		_tmp40_ = g_date_time_format (_tmp34_, _tmp39_);
#line 166 "../daemon/Daemon.vala"
		_g_free0 (secondary_text);
#line 166 "../daemon/Daemon.vala"
		secondary_text = _tmp40_;
#line 166 "../daemon/Daemon.vala"
		_g_free0 (_tmp39_);
#line 166 "../daemon/Daemon.vala"
		_g_free0 (_tmp36_);
#line 1599 "Daemon.c"
	}
#line 169 "../daemon/Daemon.vala"
	_tmp41_ = primary_text;
#line 169 "../daemon/Daemon.vala"
	_tmp42_ = g_notification_new (_tmp41_);
#line 169 "../daemon/Daemon.vala"
	notification = _tmp42_;
#line 170 "../daemon/Daemon.vala"
	_tmp43_ = notification;
#line 170 "../daemon/Daemon.vala"
	_tmp44_ = secondary_text;
#line 170 "../daemon/Daemon.vala"
	g_notification_set_body (_tmp43_, _tmp44_);
#line 171 "../daemon/Daemon.vala"
	_tmp45_ = notification;
#line 171 "../daemon/Daemon.vala"
	_tmp46_ = (GThemedIcon*) g_themed_icon_new ("office-calendar");
#line 171 "../daemon/Daemon.vala"
	_tmp47_ = _tmp46_;
#line 171 "../daemon/Daemon.vala"
	g_notification_set_icon (_tmp45_, (GIcon*) _tmp47_);
#line 171 "../daemon/Daemon.vala"
	_g_object_unref0 (_tmp47_);
#line 173 "../daemon/Daemon.vala"
	_tmp48_ = g_application_get_default ();
#line 173 "../daemon/Daemon.vala"
	_tmp49_ = notification;
#line 173 "../daemon/Daemon.vala"
	g_application_send_notification (_tmp48_, uid, _tmp49_);
#line 146 "../daemon/Daemon.vala"
	_g_object_unref0 (notification);
#line 146 "../daemon/Daemon.vala"
	_g_free0 (text);
#line 146 "../daemon/Daemon.vala"
	_g_free0 (format);
#line 146 "../daemon/Daemon.vala"
	_g_object_unref0 (h24_settings);
#line 146 "../daemon/Daemon.vala"
	_g_free0 (secondary_text);
#line 146 "../daemon/Daemon.vala"
	_g_date_time_unref0 (now);
#line 146 "../daemon/Daemon.vala"
	_g_date_time_unref0 (start_time);
#line 146 "../daemon/Daemon.vala"
	_g_free0 (primary_text);
#line 1645 "Daemon.c"
}

static void
maya_daemon_update_event (MayaDaemon* self,
                          ESource* source,
                          ECalComponent* event)
{
#line 176 "../daemon/Daemon.vala"
	g_return_if_fail (self != NULL);
#line 176 "../daemon/Daemon.vala"
	g_return_if_fail (source != NULL);
#line 176 "../daemon/Daemon.vala"
	g_return_if_fail (event != NULL);
#line 177 "../daemon/Daemon.vala"
	maya_daemon_remove_event (self, source, event);
#line 181 "../daemon/Daemon.vala"
	e_cal_component_commit_sequence (event);
#line 182 "../daemon/Daemon.vala"
	maya_daemon_add_event (self, source, event);
#line 1665 "Daemon.c"
}

static void
maya_daemon_remove_event (MayaDaemon* self,
                          ESource* source,
                          ECalComponent* event)
{
	GeeHashMap* _tmp0_;
#line 185 "../daemon/Daemon.vala"
	g_return_if_fail (self != NULL);
#line 185 "../daemon/Daemon.vala"
	g_return_if_fail (source != NULL);
#line 185 "../daemon/Daemon.vala"
	g_return_if_fail (event != NULL);
#line 186 "../daemon/Daemon.vala"
	_tmp0_ = self->priv->event_uid;
#line 186 "../daemon/Daemon.vala"
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, event)) {
#line 1684 "Daemon.c"
		GeeHashMap* _tmp1_;
#line 187 "../daemon/Daemon.vala"
		_tmp1_ = self->priv->event_uid;
#line 187 "../daemon/Daemon.vala"
		gee_abstract_map_unset ((GeeAbstractMap*) _tmp1_, event, NULL);
#line 1690 "Daemon.c"
	}
}

static GTimeSpan
maya_daemon_time_until_now (MayaDaemon* self,
                            GDateTime* dt)
{
	GTimeSpan result = 0LL;
	GDateTime* now = NULL;
	GDateTime* _tmp0_;
#line 191 "../daemon/Daemon.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 191 "../daemon/Daemon.vala"
	g_return_val_if_fail (dt != NULL, 0LL);
#line 192 "../daemon/Daemon.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 192 "../daemon/Daemon.vala"
	now = _tmp0_;
#line 193 "../daemon/Daemon.vala"
	result = g_date_time_difference (dt, now) / G_TIME_SPAN_SECOND;
#line 193 "../daemon/Daemon.vala"
	_g_date_time_unref0 (now);
#line 193 "../daemon/Daemon.vala"
	return result;
#line 1715 "Daemon.c"
}

MayaDaemon*
maya_daemon_construct (GType object_type)
{
	MayaDaemon * self = NULL;
#line 28 "../daemon/Daemon.vala"
	self = (MayaDaemon*) g_object_new (object_type, NULL);
#line 28 "../daemon/Daemon.vala"
	return self;
#line 1726 "Daemon.c"
}

MayaDaemon*
maya_daemon_new (void)
{
#line 28 "../daemon/Daemon.vala"
	return maya_daemon_construct (MAYA_TYPE_DAEMON);
#line 1734 "Daemon.c"
}

static gboolean
_maya_daemon___lambda8_ (MayaDaemon* self)
{
	gboolean result = FALSE;
	GeeHashMap* _tmp0_;
#line 34 "../daemon/Daemon.vala"
	_tmp0_ = self->priv->event_uid;
#line 34 "../daemon/Daemon.vala"
	gee_abstract_map_clear ((GeeAbstractMap*) _tmp0_);
#line 35 "../daemon/Daemon.vala"
	maya_daemon_load_today_events (self);
#line 36 "../daemon/Daemon.vala"
	result = TRUE;
#line 36 "../daemon/Daemon.vala"
	return result;
#line 1752 "Daemon.c"
}

static gboolean
__maya_daemon___lambda8__gsource_func (gpointer self)
{
	gboolean result;
	result = _maya_daemon___lambda8_ ((MayaDaemon*) self);
#line 33 "../daemon/Daemon.vala"
	return result;
#line 1762 "Daemon.c"
}

static GObject *
maya_daemon_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MayaDaemon * self;
#line 31 "../daemon/Daemon.vala"
	parent_class = G_OBJECT_CLASS (maya_daemon_parent_class);
#line 31 "../daemon/Daemon.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 31 "../daemon/Daemon.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MAYA_TYPE_DAEMON, MayaDaemon);
#line 32 "../daemon/Daemon.vala"
	maya_daemon_load_today_events (self);
#line 33 "../daemon/Daemon.vala"
	g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 86400, __maya_daemon___lambda8__gsource_func, g_object_ref (self), g_object_unref);
#line 31 "../daemon/Daemon.vala"
	return obj;
#line 1785 "Daemon.c"
}

static void
maya_daemon_class_init (MayaDaemonClass * klass,
                        gpointer klass_data)
{
#line 28 "../daemon/Daemon.vala"
	maya_daemon_parent_class = g_type_class_peek_parent (klass);
#line 28 "../daemon/Daemon.vala"
	g_type_class_adjust_private_offset (klass, &MayaDaemon_private_offset);
#line 28 "../daemon/Daemon.vala"
	((GApplicationClass *) klass)->activate = (void (*) (GApplication*)) maya_daemon_real_activate;
#line 28 "../daemon/Daemon.vala"
	G_OBJECT_CLASS (klass)->constructor = maya_daemon_constructor;
#line 28 "../daemon/Daemon.vala"
	G_OBJECT_CLASS (klass)->finalize = maya_daemon_finalize;
#line 1802 "Daemon.c"
}

static void
maya_daemon_instance_init (MayaDaemon * self,
                           gpointer klass)
{
#line 28 "../daemon/Daemon.vala"
	self->priv = maya_daemon_get_instance_private (self);
#line 1811 "Daemon.c"
}

static void
maya_daemon_finalize (GObject * obj)
{
	MayaDaemon * self;
#line 28 "../daemon/Daemon.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MAYA_TYPE_DAEMON, MayaDaemon);
#line 29 "../daemon/Daemon.vala"
	_g_object_unref0 (self->priv->event_uid);
#line 28 "../daemon/Daemon.vala"
	G_OBJECT_CLASS (maya_daemon_parent_class)->finalize (obj);
#line 1824 "Daemon.c"
}

GType
maya_daemon_get_type (void)
{
	static volatile gsize maya_daemon_type_id__volatile = 0;
	if (g_once_init_enter (&maya_daemon_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MayaDaemonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) maya_daemon_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MayaDaemon), 0, (GInstanceInitFunc) maya_daemon_instance_init, NULL };
		GType maya_daemon_type_id;
		maya_daemon_type_id = g_type_register_static (g_application_get_type (), "MayaDaemon", &g_define_type_info, 0);
		MayaDaemon_private_offset = g_type_add_instance_private (maya_daemon_type_id, sizeof (MayaDaemonPrivate));
		g_once_init_leave (&maya_daemon_type_id__volatile, maya_daemon_type_id);
	}
	return maya_daemon_type_id__volatile;
}

gint
maya_main (gchar** args,
           gint args_length1)
{
	gint result = 0;
	GOptionContext* context = NULL;
	GOptionContext* _tmp0_;
	MayaDaemon* app = NULL;
	MayaDaemon* _tmp4_;
	GError* _inner_error0_ = NULL;
#line 198 "../daemon/Daemon.vala"
	_tmp0_ = g_option_context_new ("");
#line 198 "../daemon/Daemon.vala"
	context = _tmp0_;
#line 199 "../daemon/Daemon.vala"
	g_option_context_add_main_entries (context, MAYA_options, NULL);
#line 1857 "Daemon.c"
	{
#line 202 "../daemon/Daemon.vala"
		g_option_context_parse (context, (gint*) (&args_length1), &args, &_inner_error0_);
#line 202 "../daemon/Daemon.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1863 "Daemon.c"
			gint _tmp1_ = -1;
#line 202 "../daemon/Daemon.vala"
			if (_inner_error0_->domain == G_OPTION_ERROR) {
#line 1867 "Daemon.c"
				goto __catch0_g_option_error;
			}
#line 202 "../daemon/Daemon.vala"
			_g_option_context_free0 (context);
#line 202 "../daemon/Daemon.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 202 "../daemon/Daemon.vala"
			g_clear_error (&_inner_error0_);
#line 202 "../daemon/Daemon.vala"
			return _tmp1_;
#line 1878 "Daemon.c"
		}
	}
	goto __finally0;
	__catch0_g_option_error:
	{
		GError* e = NULL;
		const gchar* _tmp2_;
#line 201 "../daemon/Daemon.vala"
		e = _inner_error0_;
#line 201 "../daemon/Daemon.vala"
		_inner_error0_ = NULL;
#line 204 "../daemon/Daemon.vala"
		_tmp2_ = e->message;
#line 204 "../daemon/Daemon.vala"
		g_error ("Daemon.vala:204: %s", _tmp2_);
#line 201 "../daemon/Daemon.vala"
		_g_error_free0 (e);
#line 1896 "Daemon.c"
	}
	__finally0:
#line 201 "../daemon/Daemon.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1901 "Daemon.c"
		gint _tmp3_ = -1;
#line 201 "../daemon/Daemon.vala"
		_g_option_context_free0 (context);
#line 201 "../daemon/Daemon.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 201 "../daemon/Daemon.vala"
		g_clear_error (&_inner_error0_);
#line 201 "../daemon/Daemon.vala"
		return _tmp3_;
#line 1911 "Daemon.c"
	}
#line 207 "../daemon/Daemon.vala"
	granite_services_logger_initialize (BUILD_APP_NAME);
#line 208 "../daemon/Daemon.vala"
	granite_services_logger_set_DisplayLevel (GRANITE_SERVICES_LOG_LEVEL_WARN);
#line 210 "../daemon/Daemon.vala"
	if (maya_has_debug) {
#line 211 "../daemon/Daemon.vala"
		granite_services_logger_set_DisplayLevel (GRANITE_SERVICES_LOG_LEVEL_DEBUG);
#line 1921 "Daemon.c"
	}
#line 214 "../daemon/Daemon.vala"
	_tmp4_ = maya_daemon_new ();
#line 214 "../daemon/Daemon.vala"
	app = _tmp4_;
#line 216 "../daemon/Daemon.vala"
	result = g_application_run ((GApplication*) app, (gint) args_length1, args);
#line 216 "../daemon/Daemon.vala"
	_g_object_unref0 (app);
#line 216 "../daemon/Daemon.vala"
	_g_option_context_free0 (context);
#line 216 "../daemon/Daemon.vala"
	return result;
#line 1935 "Daemon.c"
}

int
main (int argc,
      char ** argv)
{
#line 197 "../daemon/Daemon.vala"
	return maya_main (argv, argc);
#line 1944 "Daemon.c"
}

